/*************************************************************/
/*!	\brief	n[to[ggUƖ
*!	\author	M.Sugikawa
*!	\data	2013/06/01
**************************************************************/
float4x4	m_WVP;
float4		m_LightDir;
float4		m_Ambient	= float4(1.f,1.f,1.f,1.f);

sampler tex0	: register(s0);

struct VS_OUTPUT
{
	float4 Pos		: POSITION;
	float4 Col		: COLOR0;
	float2 Tex		: TEXCOORD0;
};

VS_OUTPUT VS(	float4	Pos		: POSITION,
				float4	Normal	: NORMAL,
				float2	Tex		: TEXCOORD0	)
{
	VS_OUTPUT	Out;
			
	Out.Pos		= mul( Pos, m_WVP );
	Out.Tex		= Tex;
			
	float3 L	= -normalize( m_LightDir.xyz );
	float3 N	= normalize( Normal.xyz );
	Out.Col		= max( m_Ambient, dot(N, L) );
						
	return Out;
}

float4 PS(	VS_OUTPUT In ) : COLOR0
{	
	float4	Out;
	float4 p	= In.Col;
	//p	= p * 0.5f + 0.5;
	//p	= p * p;

	Out	= p * tex2D( tex0, In.Tex );
						
	return	Out;
}

technique TShader
{
	pass P0
	{
		VertexShader	= compile vs_2_0 VS();
		PixelShader		= compile ps_2_0 PS();
	}
}

