float4x4	m_WVP;
float4	m_LightDir;
float4	m_EyePos;				// J̈ʒuxNg.
float4	m_Ambient		= 1.0f;
float4	m_Emissive		= 0.0f; // G~bVu.
float	m_Specular		= 0.0f;	// XyL[͈̔.
float	m_SpecularPower	= 0.0f;	// XyL[̋x.

sampler s0 : register(s0);		// IuWFNg̃eNX.

struct VS_OUTPUT
{
	float4 Pos		: POSITION;
	float4 Col		: COLOR0;   
	float2 Tex		: TEXCOORD0;
	float3 N		: TEXCOORD1;	// IuWFNg̖@xNg.
	float3 L		: TEXCOORD2;	// _烉CgʒuxNg.
	float3 E		: TEXCOORD3;	// _王_xNg.
};

VS_OUTPUT VS( float4 Pos    : POSITION,
				float4 Normal : NORMAL,
				float2 Tex    : TEXCOORD0 )
{
	VS_OUTPUT Out;
	Out.Pos = mul( Pos, m_WVP );
	Out.Tex = Tex; 

	// _ -> Cgʒu.
	// Q[ŐK.
	Out.L = -m_LightDir.xyz;

	Out.N = Normal.xyz;

	// CgxNgƖ@xNg̓ςvZ.
	Out.Col = min( max( m_Ambient, dot( Out.N, Out.L ) ) + m_Emissive, 1.0f );
//	Out.Col = min( max( m_Ambient, dot( Out.N, Out.L ) ), 1.0f );

	// _ -> _ ւ̃xNgvZ.
	Out.E = m_EyePos.xyz - Pos.xyz;

	return Out;
}

float4 PS( VS_OUTPUT In ) : COLOR0
{ 
	float4 Out;

	// @xNg𐳋K.
	float3 N = normalize( In.N );
	// _ -> CgʒuxNg + _ -> _xNg.
	float3 H = normalize( In.L + normalize( In.E ) );
	// XyL[J[vZ.
	float S = pow( max( 0.0f, dot( N, H ) ), m_Specular ) * m_SpecularPower;

	// XyL[J[Z.
	Out = In.Col * tex2D( s0, In.Tex ) + S;

	return Out;
}

technique TShader
{
	pass P0
	{
		VertexShader	= compile vs_2_0 VS();
		PixelShader		= compile ps_2_0 PS();
	}
}
