float4x4 m_WVP;                   // [hAr[Aˉe.
float4 m_LightDir;					// s̕xNg.
float4 m_MoveNormal;				// @xNg.

sampler tex0 : register(s0);		// IuWFNg̃eNX`.
sampler tex1 : register(s1);		// gD[}bveNX`.

struct VS_OUTPUT
{
	float4 Pos		: POSITION;
	float4 Color	: COLOR0;
	float3 Normal	: TEXCOORD1;
	float2 Tex		: TEXCOORD0;
};

VS_OUTPUT VS( float4 Pos		: POSITION,
				float4 Normal	: NORMAL,
				float2 Tex		: TEXCOORD0 )
{
	VS_OUTPUT Out;

	Out.Pos		= mul( Pos, m_WVP );
	Out.Tex		= Tex;

	Out.Normal	= normalize( Normal.xyz );
  
	// F.
	Out.Color.xyz	= 0.f;
	Out.Color[3]	= 1.f;// x.

	return Out;
}

float4 PS( VS_OUTPUT In ) : COLOR0
{ 
	float4 Out;

	// CeBOvZ(n[to[gVF[_[Ql).
	float p = dot( In.Normal, -m_LightDir.xyz );
	p = p * 0.5f + 0.5f;
	p = p * p;

	// iKIɐFݒ.   
	// FeNZUƂA
	// gD[}bveNX`̔˗擾.
	float4 Col = tex2D( tex1, float2( p, 0.0f ) );

	// Fi[.
	Out = Col * tex2D( tex0, In.Tex );
	
	return Out;
}

// GbW.
VS_OUTPUT VS_Edge( float4 Pos	: POSITION,
				float4 Normal	: NORMAL,
				float2 Tex		: TEXCOORD0 )
{
	VS_OUTPUT Out	= (VS_OUTPUT)0;
    
	// [JWvZ.
	float4 pos		= Pos;
	pos.xyz			= Pos.xyz + Normal.xyz * 1.0f;
	pos				= mul( pos, m_WVP );

	float4 n		= mul( Normal, m_WVP );
	n.zw			= 0;
    
	// ʒuW.
	Out.Pos			= pos;
	
	// F.
	Out.Color.xyz	= 0.f;
	Out.Color[3]	= 1.f;// x.
	
	return Out;
}

technique TShader
{
	pass P0 // ֊s`.
	{
		CullMode = CW;
		VertexShader = compile vs_2_0 VS_Edge();
	}

	pass P1
	{
		CullMode = CCW;
		VertexShader = compile vs_2_0 VS();
		PixelShader  = compile ps_2_0 PS();
	}
}
